<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed'); require_once(APPPATH . 'libraries/FilterIterator.php'); define('INOTIFY_MASK', (IN_CREATE | IN_MOVE | IN_DELETE | IN_DELETE_SELF | IN_MODIFY)); class Configs { public static $delay = 100000; public static $sweep_time = 10; public static $sync_time = 30; public static $handle_signal = array(SIGHUP, SIGUSR1, SIGUSR2, SIGINT, SIGTERM, SIGCHLD); public static $max_msg_receive = 750; public static $max_msg_length = PHP_MAXPATHLEN; public static $max_workers = 5; public static $worker_priority = 19; public static $max_depth = 10; public static $session_folder = '/usr/local/AppCentral/photo-gallery/application/session'; public static $upload_folder = '/usr/local/AppCentral/photo-gallery/application/upload'; } class JobQueue { private $CI; private $jobs = array( JOB_TYPE_CONTROL => array(), JOB_TYPE_SYNC => array(), JOB_TYPE_RESAMPLE => array(), JOB_TYPE_ROTATE => array(), JOB_TYPE_COPY => array(), JOB_TYPE_MOVE => array(), JOB_TYPE_DELETE => array() ); public function __construct() { $this->CI =& get_instance(); } public function push($job_type, $job_idx ,$job_data) { $job_data['timestamp'] = time(); $this->CI->semaphore->acquire(); $this->jobs[$job_type][$job_idx] = $job_data; $this->CI->semaphore->release(); } public function pop($job_type) { if ( ! isset($this->jobs[$job_type])) { return FALSE; } $this->CI->semaphore->acquire(); $job_idx = NULL; $job_data = NULL; foreach ($this->jobs[$job_type] as $idx => $job) { if (time() - $job['timestamp'] > 2) { $job_idx = $idx; $job_data = $job; break; } } if ($job_idx !== NULL) { unset($this->jobs[$job_type][$job_idx]); } $this->CI->semaphore->release(); if ($job_data === NULL) { return NULL; } return $job_data; } public function remove($job_type, $job_idx) { $this->CI->semaphore->acquire(); unset($this->jobs[$job_type][$job_idx]); $this->CI->semaphore->release(); } public function total($job_type = JOB_TYPE_ALL) { $total = 0; if ($job_type & JOB_TYPE_CONTROL) { $total += count($this->jobs[JOB_TYPE_CONTROL]); } if ($job_type & JOB_TYPE_SYNC) { $total += count($this->jobs[JOB_TYPE_SYNC]); } if ($job_type & JOB_TYPE_RESAMPLE) { $total += count($this->jobs[JOB_TYPE_RESAMPLE]); } if ($job_type & JOB_TYPE_ROTATE) { $total += count($this->jobs[JOB_TYPE_ROTATE]); } if ($job_type & JOB_TYPE_COPY) { $total += count($this->jobs[JOB_TYPE_COPY]); } if ($job_type & JOB_TYPE_MOVE) { $total += count($this->jobs[JOB_TYPE_MOVE]); } if ($job_type & JOB_TYPE_DELETE) { $total += count($this->jobs[JOB_TYPE_DELETE]); } return $total; } public function job_exists($job_type = JOB_TYPE_ALL) { $result = $this->total($job_type) > 0; return $result; } } class JobWorker { private $CI; private $web_config; private $workers = array( JOB_TYPE_CONTROL => array(), JOB_TYPE_SYNC => array(), JOB_TYPE_RESAMPLE => array(), JOB_TYPE_ROTATE => array(), JOB_TYPE_COPY => array(), JOB_TYPE_MOVE => array(), JOB_TYPE_DELETE => array() ); public function __construct() { $this->CI =& get_instance(); $this->web_config = $this->CI->config->item('photo_gallery'); } public function exists($worker) { extract($worker, EXTR_PREFIX_ALL, 'worker'); return in_array($worker_job, $this->workers[$worker_type]); } public function add($worker) { extract($worker, EXTR_PREFIX_ALL, 'worker'); $this->workers[$worker_type][$worker_pid] = $worker_job; } public function finish($pid) { foreach ($this->workers as &$worker) { if (array_key_exists($pid, $worker)) { unset($worker[$pid]); } } } public function cleaner() { $worker_pid = pcntl_waitpid(-1, $status, WNOHANG); while ($worker_pid > 0) { $this->finish($worker_pid); $worker_pid = pcntl_waitpid(-1, $status, WNOHANG); } } public function kill_all($signo) { $worker_pids = array(); foreach ($this->workers as $worker) { foreach ($worker as $pid => $job) { $worker_pids[] = $pid; } } foreach ($worker_pids as $pid) { posix_kill($pid, $signo); } foreach ($worker_pids as $pid) { pcntl_waitpid($pid, $status); } } public function total($job_type = JOB_TYPE_ALL) { $total = 0; if ($job_type & JOB_TYPE_CONTROL) { $total += count($this->workers[JOB_TYPE_CONTROL]); } if ($job_type & JOB_TYPE_SYNC) { $total += count($this->workers[JOB_TYPE_SYNC]); } if ($job_type & JOB_TYPE_RESAMPLE) { $total += count($this->workers[JOB_TYPE_RESAMPLE]); } if ($job_type & JOB_TYPE_ROTATE) { $total += count($this->workers[JOB_TYPE_ROTATE]); } if ($job_type & JOB_TYPE_COPY) { $total += count($this->workers[JOB_TYPE_COPY]); } if ($job_type & JOB_TYPE_MOVE) { $total += count($this->workers[JOB_TYPE_MOVE]); } if ($job_type & JOB_TYPE_DELETE) { $total += count($this->workers[JOB_TYPE_DELETE]); } return $total; } public function idle_workers() { $result = $this->total() < Configs::$max_workers; return $result; } private function _init($job) { $proc_title = 'photo-gallery-worker ' . $job; $php_version = phpversion(); if($php_version == "5.3.27"){ setproctitle($proc_title); } else{ cli_set_process_title($proc_title); } pcntl_setpriority(Configs::$worker_priority); foreach (Configs::$handle_signal as $signal) { pcntl_signal($signal, SIG_IGN); } pcntl_signal(SIGINT, SIG_DFL); pcntl_signal(SIGTERM, SIG_DFL); posix_setegid($this->web_config['web_server_gid']); posix_seteuid($this->web_config['web_server_uid']); } public function do_scan_folder($folder, $max_depth = 10) { $this->_init('scanner'); $dir_iterator = new RecursiveDirectoryIterator($folder, FilesystemIterator::SKIP_DOTS); $filter_iterator = new ImageFileFilter($dir_iterator, array_merge($this->web_config['supported_image_ext'],$this->web_config['supported_image_raw'],$this->web_config['supported_video_ext'])); $iterator = new RecursiveIteratorIterator($filter_iterator, RecursiveIteratorIterator::SELF_FIRST); $iterator->setMaxDepth(99); foreach ($iterator as $spl_file_info) { if ($spl_file_info->isDir()) { continue; } $filename = $spl_file_info->getPathname(); foreach ($this->web_config['thumbnail'] as $size => $unused_prop) { $target_image = $this->CI->as_photo->get_thumbnail_file($filename, $size); if ( ! file_exists($target_image)) { $message = array( 'priority' => PRI_LOWEST, 'filename' => $filename ); if (FALSE === @$this->CI->message_queue->send(JOB_TYPE_RESAMPLE, $message)) { return FALSE; } break; } } } } public function do_sync_db() { $this->_init('synchronize'); $this->CI->load->library('sync'); $this->CI->sync->all(); } public function do_resample_image($filename) { $this->_init('resample'); $start = time(); $status = $this->CI->as_photo->resize($filename); log_message('error',"dododo"); log_message('error',$filename); log_message('error',$status); if ($status == true){ log_message('error',"adddddd"); $this->CI->as_shm->add_photo($filename); } $end = time(); } public function do_rotate_image($filename, $angle) { $this->_init('rotate'); } public function do_copy_image($src_image_path, $dst_image_path, $perm) { $this->_init('copy'); } public function do_move_image($src_image_path, $dst_image_path, $perm) { $this->_init('move'); } public function do_delete_image($filename) { $this->_init('delete'); echo 'Delete ' . $filename . ' ...' . PHP_EOL; } private function _do_exec_sample_func() { } } class Daemon extends CLI_Controller { private $running = TRUE; private $job_queue; private $job_worker; public function start($max_workers = NULL, $worker_priority = NULL) { $proc_title = 'photo-gallery-daemon'; $php_version = phpversion(); if($php_version == "5.3.27"){ setproctitle($proc_title); } else{ cli_set_process_title($proc_title); } is_null($max_workers) or Configs::$max_workers = (int)$max_workers; is_null($worker_priority) or Configs::$worker_priority = (int)$worker_priority; foreach (Configs::$handle_signal as $signal) { pcntl_signal($signal, array(&$this, '_sig_handler')); } $this->do_daemonize(); if (FALSE === $this->lock_process($proc_title)) { die($proc_title . ' (' . $this->get_daemon_pid($proc_title) . ') is already running' . PHP_EOL); } else { echo $proc_title . ' (' . $this->get_daemon_pid($proc_title) . ') is running...' . PHP_EOL; } $this->_initialize(); $this->_sync_db(); $this->_scan_media_folder($this->web_config['photo_base']); $last_sync_time = time(); $last_sweep_time = time(); while ($this->running) { pcntl_signal_dispatch(); $this->_handle_inotify_events(); $this->_receive_msg_queue(); $this->_job_dispatcher(); $current_time = time(); if ($current_time - $last_sweep_time > Configs::$sweep_time) { $this->as_shm->sweep_session(); $this->as_shm->sweep_client_id(); $this->as_shm->sweep_photos(); $last_sweep_time = time(); } usleep(Configs::$delay); } $this->_finalize(); $this->unlock_process(); } public function stop() { $proc_title = 'photo-gallery-daemon'; $pid = $this->get_daemon_pid($proc_title); if ($pid > 0) { posix_kill($pid, SIGTERM); } } private function _clean_up($path) { $dir_iterator = new RecursiveDirectoryIterator($path, FilesystemIterator::SKIP_DOTS); $iterator = new RecursiveIteratorIterator($dir_iterator, RecursiveIteratorIterator::CHILD_FIRST); foreach ($iterator as $spl_file_info) { $spl_file_info->isDir() ? rmdir($spl_file_info) : unlink($spl_file_info); } } private function _initialize() { $this->load->library('as_photo'); $this->load->helper('file'); $this->_clean_up(Configs::$session_folder); $this->_clean_up(Configs::$upload_folder); $this->load->library('inotify'); $this->inotify->add_watch_recursive($this->web_config['photo_base'], INOTIFY_MASK, Configs::$max_depth); $this->load->library('as_shm'); $this->load->library('message_queue', array('key' => $this->msg_key)); $this->load->library('semaphore', array('key' => $this->sem_key)); $this->job_queue = new JobQueue(); $this->job_worker = new JobWorker(); } private function _finalize() { $this->as_shm->remove(); $this->message_queue->remove_queue(); $this->semaphore->remove(); } private function _clean_up_resources() { $this->inotify->close($rm_all_watch = FALSE); unset($this->job_queue); } private function _run_in_background($do_action, $params = array()) { $pid = pcntl_fork(); if ($pid == -1) { die('could not fork'); } elseif ($pid == 0) { $this->_clean_up_resources(); call_user_func_array(array($this->job_worker, $do_action), $params); exit; } else { } return $pid; } private function _scan_media_folder($path) { if ($path == $this->web_config['photo_base']) { $max_depth = Configs::$max_depth; } else { $max_depth = 10; } $this->inotify->add_watch_recursive($this->web_config['photo_base'], INOTIFY_MASK, Configs::$max_depth); $pid = $this->_run_in_background('do_scan_folder', array($path, $max_depth)); $worker = array( 'type' => JOB_TYPE_CONTROL, 'pid' => $pid, 'job' => array('scan' => $path) ); $this->job_worker->add($worker); } private function _sync_db() { $worker = array( 'type' => JOB_TYPE_SYNC, 'job' => array('sync_db') ); if ($this->job_worker->exists($worker)) { return; } $pid = $this->_run_in_background('do_sync_db'); $worker['pid'] = $pid; $this->job_worker->add($worker); } private function _sig_handler($signo) { switch ($signo) { case SIGHUP: break; case SIGUSR1: echo 'Jobs: ' . $this->job_queue->total() . PHP_EOL; echo 'Workers: ' . $this->job_worker->total() . PHP_EOL; break; case SIGUSR2: $this->inotify->show_watch_list(); break; case SIGINT: case SIGTERM: $this->running = FALSE; echo 'photo-gallery-daemon (' . getmypid() . ') is stopping... '; $this->job_worker->kill_all($signo); echo 'Done' . PHP_EOL; break; case SIGCHLD: $this->job_worker->cleaner(); break; default: } } private function _handle_inotify_events() { $events = $this->inotify->read(); foreach ($events as $event) { if ( ! $this->running) { break; } if ($event['mask'] & IN_IGNORED) { continue; } $filename = $this->inotify->get_watch_pathname($event['wd']) . DIRECTORY_SEPARATOR . $event['name']; if (strstr($filename, $this->web_config['cache_folder'])) { continue; } if (strstr($filename, $this->web_config['recycle_folder'])) { continue; } if (mb_basename($filename) === 'Thumbs.db') { unlink($filename); continue; } if ($event['mask'] & IN_DELETE_SELF) { $this->inotify->rm_watch($filename); continue; } $depth = substr_count($filename, DIRECTORY_SEPARATOR, strlen($this->web_config['photo_base'])); if ($event['mask'] & IN_ISDIR) { if ($depth > Configs::$max_depth) { continue; } switch (TRUE) { case $event['mask'] & IN_CREATE: case $event['mask'] & IN_MOVED_TO: $this->inotify->add_watch($filename, INOTIFY_MASK); $this->_scan_media_folder($filename); if ($event['mask'] & IN_CREATE) { } elseif ($event['mask'] & IN_MOVED_TO) { } break; case $event['mask'] & IN_DELETE: case $event['mask'] & IN_MOVE_SELF: case $event['mask'] & IN_DELETE_SELF: case $event['mask'] & IN_MOVED_FROM: if ($event['mask'] & IN_MOVED_FROM) { $this->inotify->rm_watch($filename); if(ENVIRONMENT == 'testing'){ $syslog_cmd = 'syslog --log 0 --level 0 --user admin --event "DAEMON inotify del '.$filename.'"'; log_message('error',$syslog_cmd); shell_exec($syslog_cmd); } } if ($event['mask'] & IN_DELETE) { } break; } $this->_sync_db(); } else { if ($depth > Configs::$max_depth + 1) { continue; } if ( ! in_array(strtolower(pathinfo($filename, PATHINFO_EXTENSION)), array_merge($this->web_config['supported_image_ext'],$this->web_config['supported_image_raw'],$this->web_config['supported_video_ext']))) { continue; } switch (TRUE) { case $event['mask'] & IN_CREATE: case $event['mask'] & IN_MODIFY: case $event['mask'] & IN_MOVED_TO: foreach ($this->web_config['thumbnail'] as $size => $unused_prop) { $cmd = " thumbnail -home ".addcslashes($filename, "\40..\51"); if(ENVIRONMENT == 'testing'){ $syslog_cmd = 'syslog --log 0 --level 0 --user admin --event "DAEMON thumb home 1 '.$cmd.'"'; log_message('error',$syslog_cmd); shell_exec($syslog_cmd); } $thumb_home = shell_exec($cmd); preg_match('/Path: (\[([\S]*)\])/', $thumb_home, $matches); $thumbs_dir = $matches[2]; if(in_array(strtolower(pathinfo($filename, PATHINFO_EXTENSION)), $this->web_config['supported_image_ext'])){ $ext = strtolower(pathinfo($filename, PATHINFO_EXTENSION)); }else{ $ext = 'jpg'; } $target_image = $thumbs_dir.$this->as_photo->get_image_size($size).'.'.$ext; if (($event['mask'] & IN_CREATE) || ($event['mask'] & IN_MODIFY)) { if ($target_image === FALSE) { continue; } if(strpos($thumbs_dir, "/volume1/.@thumbnail") === FALSE){ continue; } } if ( ! file_exists($target_image)) { $job_data = array( 'priority' => PRI_LOWEST, 'filename' => $filename, 'mtime' => filemtime($filename) ); $this->job_queue->push(JOB_TYPE_RESAMPLE, md5($filename), $job_data); break; } } if ($event['mask'] & IN_CREATE) { } elseif ($event['mask'] & IN_MODIFY) { } elseif ($event['mask'] & IN_MOVED_TO) { } break; case $event['mask'] & IN_DELETE: case $event['mask'] & IN_MOVED_FROM: if(ENVIRONMENT == 'testing'){ $syslog_cmd = 'syslog --log 0 --level 0 --user admin --event "DAEMON del file '.$filepath.'"'; log_message('error',$syslog_cmd); shell_exec($syslog_cmd); } $this->job_queue->remove(JOB_TYPE_RESAMPLE, md5($filename)); if ($event['mask'] & IN_DELETE) { } elseif ($event['mask'] & IN_MOVED_FROM) { } break; } $this->_sync_db(); } } } private function _receive_msg_queue() { $count = 0; while($this->message_queue->receive(0, $msgtype, Configs::$max_msg_length, $message)) { if ( ! $this->running || ++$count >= Configs::$max_msg_receive) { break; } switch ($msgtype) { case JOB_TYPE_CONTROL: break; case JOB_TYPE_SYNC: break; case JOB_TYPE_RESAMPLE: $job_data = array( 'filename' => $message['filename'], 'mtime' => @filemtime($message['filename']) ); $this->job_queue->push(JOB_TYPE_RESAMPLE, md5($message['filename']), $job_data); break; case JOB_TYPE_ROTATE: break; case JOB_TYPE_COPY: break; case JOB_TYPE_MOVE: break; case JOB_TYPE_DELETE: break; default: } } } private function _job_dispatcher() { while ($this->job_queue->job_exists() && $this->job_worker->idle_workers()) { if ( ! $this->running) { break; } $job_data = $this->job_queue->pop(JOB_TYPE_RESAMPLE); if ($job_data === NULL) { return; } clearstatcache(); $filemtime = @filemtime($job_data['filename']); if ($filemtime != $job_data['mtime']) { $job_data['mtime'] = $filemtime; $this->job_queue->push(JOB_TYPE_RESAMPLE, md5($job_data['filename']), $job_data); continue; } if (disk_free_space($this->web_config['photo_base']) < RESERVED_SIZE) { continue; } $do_action = 'do_resample_image'; $worker = array( 'type' => JOB_TYPE_RESAMPLE, 'job' => $job_data['filename'] ); if ($this->job_worker->exists($worker)) { continue; } $pid = $this->_run_in_background($do_action, array($worker['job'])); $worker['pid'] = $pid; $this->job_worker->add($worker); } } } 