<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed'); require_once('As_base.php'); class As_cgi extends As_base { private $sid = ''; private $uid = ''; private $account = ''; private $is_admin = ''; private $language = ''; private $err_code = 0; private $err_msg = 0; public function __construct($params = NULL) { parent::__construct(); $this->CI->load->library('as_config'); $this->CI->load->spark('curl/1.3.0'); if (isset($params['sid']) && $params['sid']) { $this->sid = $params['sid']; } } public function set_value($name, $value) { if (isset($this->{$name})) { $this->{$name} = $value; } } public function get_value($name) { if (isset($this->{$name})) { return $this->{$name}; } else { return NULL; } } public function cgi_request($cgi_path, $post = NULL) { $response = array(); $this->err_code = 0; $this->err_msg = ''; $url = $this->CI->as_config->get_cgi_url($cgi_path); $this->CI->curl->create($url); $this->CI->curl->option(CURLOPT_USERAGENT, $_SERVER['HTTP_USER_AGENT']); $this->CI->curl->option(CURLOPT_SSL_VERIFYHOST, false); $this->CI->curl->option(CURLOPT_SSL_VERIFYPEER, true); $this->CI->curl->ssl(FALSE); if ($post) { $this->CI->curl->post($post); } $response['content'] = $this->CI->curl->execute(); $response['error_code'] = $this->CI->curl->error_code; $response['error_string'] = $this->CI->curl->error_string; if (ENVIRONMENT == 'development') { $this->fb_group('[Send API to NAS]'); $this->fb_log($this->CI->curl->info['url'], 'Request URL'); $this->fb_log($post, 'Request POST'); $this->fb_log(json_decode($response['content']), 'Response'); $this->fb_groupEnd(); } return $response; } private function _login($post) { $response = $this->cgi_request($this->web_config['adm_cgi_app_login'], $post); if (isset($response['error_code'])) { return NULL; } $json = json_decode($response['content']); if ($json->success) { $this->sid = $json->sid; $this->uid = $this->CI->as_config->get_user_uid($json->account); $this->account = $json->account; $this->is_admin = $json->isAdminGroup === 1 ? TRUE : FALSE; $this->language = $this->CI->as_config->get_personal_language($this->account); return TRUE; } else { $this->err_code = $json->error_code; $this->err_msg = $json->error_msg; return FALSE; } } public function login($account, $password) { $post = array( 'act' => 'login', 'account' => $account, 'password' => $password, 'apptag' => $this->CI->as_config->get_app_value('package') ); return $this->_login($post); } public function revive($sid) { $post = array( 'act' => 'revive', 'sid' => $sid, 'apptag' => $this->CI->as_config->get_app_value('package') ); return $this->_login($post); } public function logout() { $post = array( 'act' => 'logout', 'sid' => $this->sid ); $response = $this->cgi_request($this->web_config['adm_cgi_login'], $post); if (isset($response['error_code'])) { return NULL; } $json = json_decode($response['content']); if ($json->success) { return TRUE; } else { $this->err_code = $json->error_code; $this->err_msg = $json->error_msg; return FALSE; } } private function _get_app_users() { $post = array( 'act' => 'get-users-by-app', 'sid' => $this->sid, 'app' => $this->CI->as_config->get_app_value('package'), 'start' => 0, 'limit' => -1 ); $response = $this->cgi_request($this->web_config['adm_cgi_app_privilege'], $post); if (isset($response['error_code'])) { return NULL; } $json = json_decode($response['content']); if ($json->success) { $app_users = array(); foreach ($json->items as $user) { if($user->allow == 'true'){ $app_users[] = array( 'uid' => $user->uid, 'name' => $user->user, 'description' => $user->description ); } } return $app_users; } else { $this->err_code = $json->error_code; $this->err_msg = $json->error_msg; return FALSE; } } private function _get_admin_group() { $post = array( 'act' => 'get', 'sid' => $this->sid, 'gid' => 999 ); $response = $this->cgi_request($this->web_config['adm_cgi_group'], $post); if (isset($response['error_code'])) { return NULL; } $json = json_decode($response['content']); if ($json->success) { $admin_group = explode(',', $json->users); return $admin_group; } else { $this->err_code = $json->error_code; $this->err_msg = $json->error_msg; return FALSE; } } private function _get_admin_users() { $post = array( 'act' => 'list', 'sid' => $this->sid, 'domain' => 0, 'start' => 0, 'limit' => -1 ); $response = $this->cgi_request($this->web_config['adm_cgi_user'], $post); if (isset($response['error_code'])) { return NULL; } $json = json_decode($response['content']); if ($json->success) { $admin_group = $this->_get_admin_group(); $admin_users = array(); foreach ($json->datas as $user) { if (in_array($user->name, $admin_group)) { $admin_users[] = array( 'uid' => $user->uid, 'name' => $user->name, 'description' => $user->description ); } } return $admin_users; } else { $this->err_code = $json->error_code; $this->err_msg = $json->error_msg; return FALSE; } } public static function sort_user_by_name($user1, $user2) { return strcmp($user1['name'], $user2['name']); } public function get_users() { $app_users = $this->_get_app_users(); $admin_users = $this->_get_admin_users(); if (is_array($app_users) && is_array($admin_users)) { $users = array_merge($app_users, $admin_users); uasort($users, 'As_cgi::sort_user_by_name'); return array_values($users); } else { return NULL; } } public function get_share_list() { $post = array( 'act' => 'file_list', 'sid' => $this->sid, 'showhome' => 'true', 'onlydir' => 'true', 'path' => 'share_folders' ); $response = $this->cgi_request($this->web_config['adm_cgi_file_explorer'], $post); log_message('info',$response); if (isset($response['error_code'])) { return NULL; } $json = json_decode($response['content']); log_message('info','json success'); if ($json->success) { $share_list = array(); foreach ($json->data as $share) { $bin = decbin($share->access_permission); $bin = substr("0000000000000",0,13 - strlen($bin)) . $bin; $permit_READ_DATA = substr($bin, 12, 1); $permit_EXECUTE = substr($bin, 7, 1); if ($permit_READ_DATA == "0" || $permit_EXECUTE == "0" ) { continue; } if ($share->filename == $this->web_config['share_folder']) { continue; } $share_list[$share->filename] = array( 'path' => str_replace ('\\', '', $share->physical_path), 'type' => $share->share_folder_type, 'node' => $share->exist_subdir ); } return $share_list; } else { $this->err_code = $json->error_code; $this->err_msg = $json->error_msg; return FALSE; } } public function get_sysinfo() { $post = array( 'act' => 'sys', 'sid' => $this->sid ); $response = $this->cgi_request($this->web_config['adm_cgi_sys_info'], $post); if (isset($response['error_code'])) { return NULL; } $json = json_decode($response['content']); if ($json->success) { $sysinfo = array( 'model' => $json->model, 'version' => $json->os, 'cpu' => $json->cpu, 'memory' => $json->mem, 'serial' => $json->serial, 'bios' => $json->bios ); if (isset($json->bootloader)) { $sysinfo['bootloader'] = $json->bootloader; } return $sysinfo; } else { $this->err_code = $json->error_code; $this->err_msg = $json->error_msg; return FALSE; } } public function get_cloud_id() { $post = array( 'act' => 'cloudid_status', 'sid' => $this->sid ); $response = $this->cgi_request($this->web_config['adm_cgi_cloud_id'], $post); if (isset($response['error_code'])) { return NULL; } $json = json_decode($response['content']); if ($json->success) { $cloud_id = array( 'enable' => $json->status == 1 ? TRUE : FALSE, 'hostname' => $json->cloud_id . '.myasustor.com' ); return $cloud_id; } else { $this->err_code = $json->error_code; $this->err_msg = $json->error_msg; return FALSE; } } public function get_ddns() { $post = array( 'act' => 'get', 'sid' => $this->sid ); $response = $this->cgi_request($this->web_config['adm_cgi_ddns'], $post); if (isset($response['error_code'])) { return NULL; } $json = json_decode($response['content']); if ($json->success) { $ddns = array( 'enable' => $json->run_service == 1 ? TRUE : FALSE, 'hostname' => $json->hostname ); return $ddns; } else { $this->err_code = $json->error_code; $this->err_msg = $json->error_msg; return FALSE; } } private function _get_mysql_settings() { $post = array( 'act' => 'get', 'sid' => $this->sid ); $response = $this->cgi_request($this->web_config['adm_cgi_mysql'], $post); if (isset($response['error_code'])) { return NULL; } $json = json_decode($response['content']); if ( ! $json->success) { $this->err_code = $json->error_code; $this->err_msg = $json->error_msg; return FALSE; } $data = array( 'enable' => $json->enable === 1 ? TRUE : FALSE, 'port' => $json->port, 'remote' => $json->remote_access ); return $data; } public function start_mysql() { $setting = $this->_get_mysql_settings(); if ($setting['enable'] === TRUE) { return TRUE; } $post = array( 'act' => 'set', 'sid' => $this->sid, 'enable' => TRUE, 'port' => $setting['port'], 'remote_access' => $setting['remote'] ); $response = $this->cgi_request($this->web_config['adm_cgi_mysql'], $post); if (isset($response['error_code'])) { return NULL; } $json = json_decode($response['content']); if ( ! $json->success) { $this->err_code = $json->error_code; $this->err_msg = $json->error_msg; return FALSE; } return TRUE; } public function generate_preview_image($share_path, $width, $height) { $post = array( 'act' => 'preview_img', 'sid' => $this->sid, 'width' => $width, 'height' => $height ); $response = $this->cgi_request($this->web_config['adm_cgi_fe_download'] . '?file=' . rawurlencode($share_path), $post); if (isset($response['error_code'])) { return NULL; } return TRUE; } public function get_folder_list($path) { $post = array( 'act' => 'file_list', 'sid' => $this->sid, 'onlydir' => 'true', 'path' => $path ); $response = $this->cgi_request($this->web_config['adm_cgi_file_explorer'], $post); if (isset($response['error_code'])) { return NULL; } $json = json_decode($response['content']); log_message('info','json success'); if ($json->success) { $share_list = array(); foreach ($json->data as $share) { $bin = decbin($share->access_permission); $bin = substr("0000000000000",0,13 - strlen($bin)) . $bin; $permit_READ_DATA = substr($bin, 12, 1); $permit_EXECUTE = substr($bin, 7, 1); if ($permit_READ_DATA == "0" || $permit_EXECUTE == "0" ) { continue; } if($share->filename == '#Recycle'){ continue; } $w = ''; if ($share->exist_subdir==1) { $w = '1'; } else{ $w = ''; } $dir = array( 'name' => str_replace ('\\', '', $share->filename), 'type' => 2, 'node' => $w ); array_push($share_list, $dir); } return $share_list; } else { $this->err_code = $json->error_code; $this->err_msg = $json->error_msg; return FALSE; } } public function get_file_list($real_path) { $path = preg_replace('/^\/volume\d+\//', DIRECTORY_SEPARATOR,$real_path); $post = array( 'act' => 'file_list', 'sid' => $this->sid, 'onlydir' => 'false', 'path' => $path ); $response = $this->cgi_request($this->web_config['adm_cgi_file_explorer'], $post); if (isset($response['error_code'])) { return NULL; } $json = json_decode($response['content']); log_message('info','json success'); if ($json->success) { $share_list = array(); foreach ($json->data as $share) { $bin = decbin($share->access_permission); $bin = substr("0000000000000",0,13 - strlen($bin)) . $bin; $permit_READ_DATA = substr($bin, 12, 1); $permit_EXECUTE = substr($bin, 7, 1); if ($permit_READ_DATA == "0") { continue; } if ($share->is_dir == '1'){ continue; } if ( ! in_array(strtolower(pathinfo($share->filename, PATHINFO_EXTENSION)), array_merge($this->web_config['supported_image_ext'],$this->web_config['supported_image_raw'], $this->web_config['supported_video_ext']))) { continue; } $w = ''; if ($share->exist_subdir==1) { $w = '1'; } else{ $w = ''; } $dir = array( 'name' => str_replace ('\\', '', $share->filename), 'type' => 2, 'node' => $w ); array_push($share_list, $dir); } return $share_list; } else { $this->err_code = $json->error_code; $this->err_msg = $json->error_msg; return FALSE; } } public function get_share_list_nas() { $post = array( 'act' => 'file_list', 'sid' => $this->sid, 'showhome' => 'true', 'onlydir' => 'true', 'path' => 'share_folders' ); $response = $this->cgi_request($this->web_config['adm_cgi_file_explorer'], $post); log_message('info',$response); if (isset($response['error_code'])) { return NULL; } $json = json_decode($response['content']); log_message('info','json success'); if ($json->success) { $share_list = array(); foreach ($json->data as $share) { $bin = decbin($share->access_permission); $bin = substr("0000000000000",0,13 - strlen($bin)) . $bin; $permit_READ_DATA = substr($bin, 12, 1); $permit_EXECUTE = substr($bin, 7, 1); if ($permit_READ_DATA == "0" || $permit_EXECUTE == "0" ) { continue; } if ($share->filename == $this->web_config['share_folder']) { continue; } $share_list[$share->filename] = array( 'path' => str_replace ('\\', '', $share->file_path), 'type' => $share->share_folder_type, 'node' => $share->exist_subdir ); } return $share_list; } else { $this->err_code = $json->error_code; $this->err_msg = $json->error_msg; return FALSE; } } } 