<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed'); class As_shm { private $CI; private $sem_identifier; public function __construct() { $this->CI =& get_instance(); $shm_key = ftok(__FILE__, 'm'); $sem_key = ftok(__FILE__, 's'); $this->CI->load->library('shared_memory', array('key' => $shm_key, 'memsize' => 102400), 'my_shm'); $this->sem_identifier = sem_get($sem_key); $this->_initialize(); } private function _initialize() { sem_acquire($this->sem_identifier); if ( ! $this->CI->my_shm->has_var('sessions')) { $this->CI->my_shm->put_var('sessions', array()); } if ( ! $this->CI->my_shm->has_var('client_id')) { $this->CI->my_shm->put_var('client_id', array()); } if ( ! $this->CI->my_shm->has_var('photos')) { $this->CI->my_shm->put_var('photos', array()); } sem_release($this->sem_identifier); } private function _get_uptime() { list($uptime, ) = explode(' ', file_get_contents('/proc/uptime')); return (int)$uptime; } public function dump() { sem_acquire($this->sem_identifier); $sessions = $this->CI->my_shm->get_var('sessions'); $client_id = $this->CI->my_shm->get_var('client_id'); $photos = $this->CI->my_shm->get_var('photos'); sem_release($this->sem_identifier); $data = array( 'sessions' => $sessions, 'client_id' => $client_id, 'photos' => $photos ); return $data; } public function add_session($session_id, $user_id) { sem_acquire($this->sem_identifier); $sessions = $this->CI->my_shm->get_var('sessions'); $sessions[$session_id] = array( 'user_id' => $user_id, 'timestamp' => time() ); $this->CI->my_shm->put_var('sessions', $sessions); sem_release($this->sem_identifier); } public function get_session($session_id) { sem_acquire($this->sem_identifier); $sessions = $this->CI->my_shm->get_var('sessions'); sem_release($this->sem_identifier); return isset($sessions[$session_id]) ? $sessions[$session_id] : FALSE; } public function revive_session($session_id) { sem_acquire($this->sem_identifier); $sessions = $this->CI->my_shm->get_var('sessions'); if (isset($sessions[$session_id])) { $sessions[$session_id] = array( 'user_id' => $sessions[$session_id]['user_id'], 'timestamp' => time() ); } else { $sessions[$session_id] = array( 'user_id' => FALSE, 'timestamp' => time() ); } $this->CI->my_shm->put_var('sessions', $sessions); sem_release($this->sem_identifier); } public function del_session($session_id) { sem_acquire($this->sem_identifier); $sessions = $this->CI->my_shm->get_var('sessions'); unset($sessions[$session_id]); $this->CI->my_shm->put_var('sessions', $sessions); sem_release($this->sem_identifier); } public function sweep_session() { $current_time = time(); sem_acquire($this->sem_identifier); $sessions = $this->CI->my_shm->get_var('sessions'); $copy_sessions = $sessions; foreach ($sessions as $session_id => $session_data) { if ($current_time - $session_data['timestamp'] >= 10) { unset($copy_sessions[$session_id]); } } $this->CI->my_shm->put_var('sessions', $copy_sessions); sem_release($this->sem_identifier); } public function add_client_id($cid) { sem_acquire($this->sem_identifier); $client_id = $this->CI->my_shm->get_var('client_id'); $client_id[$cid] = time(); $this->CI->my_shm->put_var('client_id', $client_id); sem_release($this->sem_identifier); } public function sweep_client_id() { $current_time = time(); sem_acquire($this->sem_identifier); $client_id = $this->CI->my_shm->get_var('client_id'); $copy_client_id = $client_id; foreach ($client_id as $cid => $timestamp) { if ($current_time - $timestamp >= 45) { unset($copy_client_id[$cid]); } } $this->CI->my_shm->put_var('client_id', $copy_client_id); sem_release($this->sem_identifier); } public function add_photo($filename) { log_message('error',"zzzzz1"); $this->CI->load->library('as_photo'); $client_id = $this->CI->my_shm->get_var('client_id'); if (empty($client_id)) { log_message('error',"ORZZZZZZZZZZZZZZZZZZZ"); return; } log_message('error',"zzzzz2"); log_message('error',$filename); @$image_size = getimagesize($filename); @list($width, $height) = $this->CI->as_photo->get_thumbnail_size($image_size[0], $image_size[1], 'M'); $current_time = time(); $photo = array( 'album_id' => fileinode(dirname($filename)), 'photo_id' => @fileinode($filename), 'dimX' => $width ?: 0, 'dimY' => $height ?: 0, 'mtime' => @filemtime($filename) + $this->_get_uptime(), 'utime' => $current_time, 'client_id' => serialize($client_id) ); log_message('error',"zzzzz3"); sem_acquire($this->sem_identifier); $this->CI->load->model('photo_pool_model'); $this->CI->photo_pool_model->initialize(array('user_id' => ADMIN_UID)); $this->CI->photo_pool_model->add_photo_to_pool($photo); log_message('error',"zzzzz4"); sem_release($this->sem_identifier); } public function get_photos($cid) { $ret_photos = array(); sem_acquire($this->sem_identifier); $this->CI->load->model('photo_pool_model'); $this->CI->load->model('photo_model'); $this->CI->photo_pool_model->initialize(array('user_id' => ADMIN_UID)); $this->CI->load->library('as_photo'); $photos = $this->CI->photo_pool_model->get_photo_from_pool(); $ret_photos = array(); foreach ($photos as $photo) { $photo->client_id = unserialize($photo->client_id); if ( ! isset($photo->client_id[$cid])) { continue; } $filepath = $this->CI->photo_model->get_path($photo->album_id, $photo->photo_id); $status = $this->CI->as_photo->check_thumb_status($filepath); if($status == 0){ $ret_photos[] = array( 'album_id' => $photo->album_id, 'photo_id' => $photo->photo_id, 'dimX' => $photo->dimX, 'dimY' => $photo->dimY, 'mtime' => $photo->mtime ); log_message('error',"!!!!!!!!!!!!"); log_message('error',$filepath); log_message('error',$status); unset($photo->client_id[$cid]); $this->CI->photo_pool_model->remove_photo_from_pool($photo->album_id,$photo->photo_id); } } unset($photo); sem_release($this->sem_identifier); return $ret_photos; } public function sweep_photos() { $current_time = time(); sem_acquire($this->sem_identifier); $photos = $this->CI->my_shm->get_var('photos'); $photos_copy = $photos; foreach ($photos as $idx => $photo) { if ($current_time - $photo['utime'] >= 10) { unset($photos_copy[$idx]); } } $this->CI->my_shm->put_var('photos', $photos_copy); sem_release($this->sem_identifier); } public function remove() { $this->CI->my_shm->remove(); sem_remove($this->sem_identifier); } } 