<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed'); class RecursiveCustomFilterIterator extends RecursiveFilterIterator { public function accept() { $result = ! preg_match('/^\./', $this->current()->getFilename()); $result &= $this->current()->isDir(); return $result; } } class Inotify { private $handle; private $wds = array(); public function __construct() { $this->handle = inotify_init(); } public function __destruct() { $this->close(); } private function _is_extension_loaded() { return extension_loaded('inotify'); } private function _get_mask_events($mask) { $mask_events = array(); ($mask & IN_ACCESS) and $mask_events[] = array('IN_ACCESS' , 'File was accessed (read) (*)'); ($mask & IN_MODIFY) and $mask_events[] = array('IN_MODIFY' , 'File was modified (*)'); ($mask & IN_ATTRIB) and $mask_events[] = array('IN_ATTRIB' , 'Metadata changed (e.g. permissions, mtime, etc.) (*)'); ($mask & IN_CLOSE_WRITE) and $mask_events[] = array('IN_CLOSE_WRITE' , 'File opened for writing was closed (*)'); ($mask & IN_CLOSE_NOWRITE) and $mask_events[] = array('IN_CLOSE_NOWRITE' , 'File not opened for writing was closed (*)'); ($mask & IN_OPEN) and $mask_events[] = array('IN_OPEN' , 'File was opened (*)'); ($mask & IN_MOVED_TO) and $mask_events[] = array('IN_MOVED_TO' , 'File moved into watched directory (*)'); ($mask & IN_MOVED_FROM) and $mask_events[] = array('IN_MOVED_FROM' , 'File moved out of watched directory (*)'); ($mask & IN_CREATE) and $mask_events[] = array('IN_CREATE' , 'File or directory created in watched directory (*)'); ($mask & IN_DELETE) and $mask_events[] = array('IN_DELETE' , 'File or directory deleted in watched directory (*)'); ($mask & IN_DELETE_SELF) and $mask_events[] = array('IN_DELETE_SELF' , 'Watched file or directory was deleted'); ($mask & IN_MOVE_SELF) and $mask_events[] = array('IN_MOVE_SELF' , 'Watch file or directory was moved'); ($mask & IN_CLOSE) and $mask_events[] = array('IN_CLOSE' , 'Equals to IN_CLOSE_WRITE | IN_CLOSE_NOWRITE'); ($mask & IN_MOVE) and $mask_events[] = array('IN_MOVE' , 'Equals to IN_MOVED_FROM | IN_MOVED_TO'); ($mask & IN_ALL_EVENTS) and $mask_events[] = array('IN_ALL_EVENTS' , 'Bitmask of all the above constants'); ($mask & IN_UNMOUNT) and $mask_events[] = array('IN_UNMOUNT' , 'File system containing watched object was unmounted'); ($mask & IN_Q_OVERFLOW) and $mask_events[] = array('IN_Q_OVERFLOW' , 'Event queue overflowed (wd is -1 for this event)'); ($mask & IN_IGNORED) and $mask_events[] = array('IN_IGNORED' , 'Watch was removed (explicitly by inotify_rm_watch() or because file was removed or filesystem unmounted'); ($mask & IN_ISDIR) and $mask_events[] = array('IN_ISDIR' , 'Subject of this event is a directory'); ($mask & IN_ONLYDIR) and $mask_events[] = array('IN_ONLYDIR' , 'Only watch pathname if it is a directory (Since Linux 2.6.15)'); ($mask & IN_DONT_FOLLOW) and $mask_events[] = array('IN_DONT_FOLLOW' , 'Do not dereference pathname if it is a symlink (Since Linux 2.6.15)'); ($mask & IN_MASK_ADD) and $mask_events[] = array('IN_MASK_ADD' , 'Add events to watch mask for this pathname if it already exists (instead of replacing mask).'); ($mask & IN_ONESHOT) and $mask_events[] = array('IN_ONESHOT' , 'Monitor pathname for one event, then remove from watch list.'); return $mask_events; } public function show_mask_event($mask) { $mask_events = $this->_get_mask_events($mask); foreach ($mask_events as $mask_event) { echo $mask_event[0] . ': ' . $mask_event[1] . PHP_EOL; } } public function show_watch_list() { foreach ($this->wds as $wd => $watched_path) { printf("[%04d] %s\n", $wd, $watched_path); } echo 'Total: ' . count($this->wds) . ' watched directory' . PHP_EOL; } public function get_watch_pathname($watch_descriptor) { return $this->wds[$watch_descriptor]; } public function add_watch($pathname, $mask) { if (is_dir($pathname)) { $pathname = rtrim($pathname, DIRECTORY_SEPARATOR); } $watch_descriptor = inotify_add_watch($this->handle, $pathname, $mask); $this->wds[$watch_descriptor] = $pathname; return $watch_descriptor; } public function add_watch_recursive($pathname, $mask, $max_depth = 10) { $wds = array(); if ( ! is_dir($pathname)) { return FALSE; } $watch_descriptor = $this->add_watch($pathname, $mask); $wds[] = $watch_descriptor; $dir_iterator = new RecursiveDirectoryIterator($pathname); $filter_iterator = new RecursiveCustomFilterIterator($dir_iterator); $iterator = new RecursiveIteratorIterator($filter_iterator, RecursiveIteratorIterator::SELF_FIRST); $iterator->setMaxDepth($max_depth - 1); foreach ($iterator as $spl_file_info) { $watch_descriptor = $this->add_watch($spl_file_info->getPathname(), $mask); $wds[] = $watch_descriptor; } return $wds; } public function rm_watch($pathname) { $result = FALSE; if (is_dir($pathname)) { $pathname = rtrim($pathname, DIRECTORY_SEPARATOR); } foreach ($this->wds as $wd => $watched_path) { if ($watched_path == $pathname) { @$result = inotify_rm_watch($this->handle, $wd); unset($this->wds[$wd]); break; } } return $result; } public function rm_all_watch() { foreach ($this->wds as $wd => $watched_path) { @inotify_rm_watch($this->handle, $wd); unset($this->wds[$wd]); } } public function queue_len() { return inotify_queue_len($this->handle); } public function read($blocking = FALSE) { if ($blocking === FALSE) { $read = array($this->handle); $write = NULL; $except = NULL; stream_select($read, $write, $except, 0); stream_set_blocking($this->handle, 0); } $events = inotify_read($this->handle); if ($events === FALSE) { $events = array(); } return $events; } public function close($rm_all_watch = TRUE) { if ($this->handle) { if ($rm_all_watch) { $this->rm_all_watch(); } fclose($this->handle); unset($this->wds); $this->handle = NULL; $this->wds = array(); } } } 