<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed'); class Zip_stream { const VERSION = '0.2.2-unicode'; var $opt = array(), $files = array(), $cdr_ofs = 0, $ofs = 0; function __construct($params = NULL) { $name = isset($params['name']) ? $params['name'] : NULL; $this->opt = isset($params['opt']) ? $params['opt'] : array(); if ( ! isset($this->opt['large_file_size'])) $this->opt['large_file_size'] = 20 * 1024 * 1024; if ( ! isset($this->opt['large_file_method'])) $this->opt['large_file_method'] = 'store'; $this->output_name = $name; if ($name || $opt['send_http_headers']) $this->need_headers = true; } function add_file($name, $data, $opt = array()) { $zdata = gzdeflate($data); $crc = crc32($data); $zlen = strlen($zdata); $len = strlen($data); $meth = 0x08; $this->add_file_header($name, $opt, $meth, $crc, $zlen, $len); $this->send($zdata); } function add_file_from_path($name, $path, $opt = array()) { if ( ! is_dir($path) && $this->is_large_file($path)) { $this->add_large_file($name, $path, $opt); } else { $data = file_get_contents($path); $this->add_file($name, $data, $opt); } } function finish() { $this->add_cdr($this->opt); $this->clear(); } public function extra_field_unicode_info($data, $type) { $data_size = 1 + 4 + strlen($data); if ($type == 'path') { $tag = 0x7075; } elseif ($type == 'comment') { $tag = 0x6375; } $fields = array( array('v', $tag), array('v', $data_size), array('c', 0x01), array('V', crc32($data)), ); $extra_field = $this->pack_fields($fields) . $data; return $extra_field; } private function add_file_header($name, $opt, $meth, $crc, $zlen, $len) { $name = preg_replace('/^\\/+/', '', $name); $nlen = strlen($name); $opt['time'] = isset($opt['time']) ? $opt['time'] : time(); $dts = $this->dostime($opt['time']); $extra_field = ''; $extra_len = strlen($extra_field); $fields = array( array('V', 0x04034b50), array('v', 0x000A), array('v', 0x0800), array('v', $meth), array('V', $dts), array('V', $crc), array('V', $zlen), array('V', $len), array('v', $nlen), array('v', $extra_len), ); $ret = $this->pack_fields($fields); $cdr_len = strlen($ret) + $nlen + $zlen + $extra_len; $this->send($ret . $name . $extra_field); $this->add_to_cdr($name, $opt, $meth, $crc, $zlen, $len, $extra_field, $cdr_len); } private function add_large_file($name, $path, $opt = array()) { $st = stat($path); $block_size = 4096; $algo = 'crc32b'; $zlen = $len = $st['size']; $meth_str = $this->opt['large_file_method']; if ($meth_str == 'store') { $meth = 0x00; $crc = unpack('N', hash_file($algo, $path, true)); $crc = $crc[1]; } elseif ($meth_str == 'deflate') { $meth = 0x08; $fh = fopen($path, 'rb'); $hash_ctx = hash_init($algo); $zlen = 0; while ($data = fgets($fh, $block_size)) { hash_update($hash_ctx, $data); $data = gzdeflate($data); $zlen += strlen($data); } fclose($fh); $crc = unpack('N', hash_final($hash_ctx, true)); $crc = $crc[1]; } else { die("unknown large_file_method: $meth_str"); } $this->add_file_header($name, $opt, $meth, $crc, $zlen, $len); $fh = fopen($path, 'rb'); while ($data = fgets($fh, $block_size)) { if ($meth_str == 'deflate') $data = gzdeflate($data); $this->send($data); } fclose($fh); } function is_large_file($path) { $st = stat($path); return ($this->opt['large_file_size'] > 0) && ($st['size'] > $this->opt['large_file_size']); } private function add_to_cdr($name, $opt, $meth, $crc, $zlen, $len, $extra_field, $rec_len) { $this->files[] = array($name, $opt, $meth, $crc, $zlen, $len, $extra_field, $this->ofs); $this->ofs += $rec_len; } private function add_cdr_file($args) { list ($name, $opt, $meth, $crc, $zlen, $len, $extra_field, $ofs) = $args; $comment = isset($opt['comment']) ? $opt['comment'] : ''; $dts = $this->dostime($opt['time']); $fields = array( array('V', 0x02014b50), array('v', 0x0300), array('v', 0x000A), array('v', 0x0800), array('v', $meth), array('V', $dts), array('V', $crc), array('V', $zlen), array('V', $len), array('v', strlen($name)), array('v', strlen($extra_field)), array('v', strlen($comment)), array('v', 0), array('v', 0), array('V', 32), array('V', $ofs), ); $ret = $this->pack_fields($fields) . $name . $extra_field . $comment; $this->send($ret); $this->cdr_ofs += strlen($ret); } private function add_cdr_eof($opt = null) { $num = count($this->files); $cdr_len = $this->cdr_ofs; $cdr_ofs = $this->ofs; $comment = ''; if ($opt && isset($opt['comment'])) $comment = $opt['comment']; $fields = array( array('V', 0x06054b50), array('v', 0x00), array('v', 0x00), array('v', $num), array('v', $num), array('V', $cdr_len), array('V', $cdr_ofs), array('v', strlen($comment)), ); $ret = $this->pack_fields($fields) . $comment; $this->send($ret); } private function add_cdr($opt = null) { foreach ($this->files as $file) $this->add_cdr_file($file); $this->add_cdr_eof($opt); } function clear() { $this->files = array(); $this->ofs = 0; $this->cdr_ofs = 0; $this->opt = array(); } private function send_http_headers() { $CI =& get_instance(); $CI->load->library('user_agent'); $opt = $this->opt; $content_type = 'application/x-zip'; if (isset($opt['content_type'])) $content_type = $this->opt['content_type']; $disposition = 'attachment'; if (isset($opt['content_disposition'])) $disposition = $opt['content_disposition']; if ($this->output_name) { if ($CI->agent->is_browser('Internet Explorer')) { $disposition .= "; filename=" . rawurlencode($this->output_name); } else { $disposition .= '; filename="' . $this->output_name . '"'; } } $headers = array( 'Content-Type' => $content_type, 'Content-Disposition' => $disposition, 'Pragma' => 'public', 'Cache-Control' => 'public, must-revalidate', 'Content-Transfer-Encoding' => 'binary', ); foreach ($headers as $key => $val) header("$key: $val"); } private function send($str) { if ($this->need_headers) $this->send_http_headers(); $this->need_headers = false; echo $str; } function dostime($when = 0) { $d = getdate($when); if ($d['year'] < 1980) { $d = array('year' => 1980, 'mon' => 1, 'mday' => 1, 'hours' => 0, 'minutes' => 0, 'seconds' => 0); } $d['year'] -= 1980; return ($d['year'] << 25) | ($d['mon'] << 21) | ($d['mday'] << 16) | ($d['hours'] << 11) | ($d['minutes'] << 5) | ($d['seconds'] >> 1); } function pack_fields($fields) { list ($fmt, $args) = array('', array()); foreach ($fields as $field) { $fmt .= $field[0]; $args[] = $field[1]; } array_unshift($args, $fmt); return call_user_func_array('pack', $args); } }; ?>
